float4x4 mTransform;			// ϊs

float4x4 mBoneMatrixArray[32];	// {[ps
int BoneWeightCount;			// {[EFCg

bool LightIsUse[4];				// CgFgpLtO
bool LightIsDirectional[4];		// CgFstO
float LightAttenuation[4];		// CgFX|bgCg
float4 LightColor[4];			// CgFF
float4 LightParameter[4];		// CgForʒu

float4 MaterialDiffuse;			// }eAFfBt[Y
float4 MaterialAmbient;			// }eAFArGg


struct VS_INPUT
{
    float4 Position		: POSITION;		// _ʒu
    float3 Normal		: NORMAL;		// _@
    float4 BlendWeights	: BLENDWEIGHT;	// _EFCg
    float4 BlendIndices	: BLENDINDICES;	// {[CfbNX
    float4 Diffuse		: COLOR0;		// _F
    float2 TexUV		: TEXCOORD0;	// tu
};

struct VS_OUTPUT
{
    float4 Position		: POSITION;		// ʒu
    float4 Color		: COLOR0;		// F
	float2 TexUV		: TEXCOORD0;	// tu
};

VS_OUTPUT SampleBoneVertexShader( const VS_INPUT Input, uniform int WeightCount )
{
	float LastWeight = 1.0;
	int4 IndexVector;
	float4 vPos = { 0, 0, 0, 0 };
	float4 vNorm = { 0, 0, 0, 0 };

	// o̓f[^
    VS_OUTPUT Output = (VS_OUTPUT)0;

    // Geforce3łUBYTE4gȂ߂ɂނȂEEE 
    IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // [vł܂킷߂ɔzɃLXg
    float WeightsArray[4] = (float[4])Input.BlendWeights;
    int IndexArray[4] = (int[4])IndexVector;

	// \ȃ{[sB
	// Ō̃{[ɊւĂ̓EFCgZo邽߂
	// ̏s
	for ( int i = 0; i < WeightCount-1; i++ )
	{
		LastWeight -= WeightsArray[i];

		vPos += mul( Input.Position, mBoneMatrixArray[IndexArray[i]]) * WeightsArray[i];
		vNorm += mul( Input.Normal, mBoneMatrixArray[IndexArray[i]]) * WeightsArray[i];
	}

    // EFCg̍Ō̒lg
    vPos += mul( Input.Position, mBoneMatrixArray[IndexArray[WeightCount-1]]) * LastWeight;
    vNorm += mul( Input.Normal, mBoneMatrixArray[IndexArray[WeightCount-1]]) * LastWeight; 

	// Wϊ
    Output.Position = mul( vPos, mTransform );

	// eNX`tu
	Output.TexUV.xy = Input.TexUV.xy;

	// fBNViCg
	float Pow = -dot( LightParameter[0], vNorm );	// Cg
	float4 Color = max( 0, LightColor[0] * Pow );	// Cg̐FZo

	// }eȀl
	Output.Color = min( 1, (Color * MaterialDiffuse) + MaterialAmbient );
	Output.Color.a = MaterialDiffuse.a;

    return Output;
}

VertexShader VsArray[4] = {
	compile vs_2_0 SampleBoneVertexShader(1), 
	compile vs_2_0 SampleBoneVertexShader(2),
	compile vs_2_0 SampleBoneVertexShader(3),
	compile vs_2_0 SampleBoneVertexShader(4)
};

technique SampleShader
{
	//--------------------------------- pXO
	pass P0
	{
		// yobt@͂nm
		ZEnable = TRUE;
		ZWriteEnable = TRUE;

        // JOKp
        CullMode = NONE;

		// eNX`[h
		ColorArg1[0] = TEXTURE;
		ColorArg2[0] = CURRENT;
		ColorOp[0] = MODULATE;

        // eNX`JԂ[h
        AddressU[0] = WRAP;
        AddressV[0] = WRAP;

		// oCjAtB^OOFF
        MinFilter[0] = POINT;
        MagFilter[0] = POINT;
        MipFilter[0] = POINT;

		// _VF[_[
		VertexShader = (VsArray[BoneWeightCount]);
	}
}

